/* -*-java-*- ttanh.java */

import java.io.*;

public class ttanh
{
    // shorthands to avoid the need for fully-qualified names, sigh...
    private static float ABS(float x)			{ return (elefunt.ABS(x)); }
    private static float ALOG(float x)			{ return (elefunt.ALOG(x)); }
    private static float AMAX1(float x,float y)		{ return (elefunt.AMAX1(x,y)); }
    private static float IPOW(float x, int n)		{ return (elefunt.IPOW(x,n)); }
    private static float POW(float x,float y)		{ return (elefunt.POW(x,y)); }
    private static float RAN()				{ return (elefunt.RAN()); }
    private static float SQRT(float x)			{ return (elefunt.SQRT(x)); }
    private static float TANH(float x)			{ return (elefunt.TANH(x)); }
    private static float TO_FP_T(long n)		{ return (elefunt.TO_FP_T(n)); }

    public static void ttanh()
    {
	/*
	#     program to test tanh
	#
	#     data required
	#
	#        none
	#
	#     subprograms required from this package
	#
	#        machar - an environmental inquiry program providing
	#                 information on the floating-point arithmetic
	#                 system.  note that the call to machar can
	#                 be deleted provided the following five
	#                 parameters are assigned the values indicated
	#
	#                 ibeta  - the radix of the floating-point system
	#                 it     - the number of base-ibeta digits in the
	#                          significand of a floating-point number
	#                 minexp - the largest in magnitude negative
	#                          integer such that float(ibeta)**minexp
	#                          is a positive floating-point number
	#                 xmin   - the smallest non-vanishing floating-point
	#                          power of the radix
	#                 xmax   - the largest finite floating-point no.
	#
	#        ran(k) - a function subprogram returning random real
	#                 numbers uniformly distributed over (0,1)
	#
	#
	#     standard fortran subprograms required
	#
	#         abs, alog, amax1, float, sqrt, tanh
	#
	#
	#     latest revision - december 6, 1979
	#
	#     author - w. j. cody
	#              argonne national laboratory
	#
	#*/

	final float ait = TO_FP_T(machar.it);
	final float beta = TO_FP_T(machar.ibeta);
	final float albeta = ALOG(beta);
	final float ONE = elefunt.ONE;
	final float ZERO = elefunt.ZERO;

	int i,
	    j,
	    k1,
	    k2,
	    k3,
	    n;

	float
	    a,
	    b,
	    betap,
	    c,
	    d,
	    del,
	    expon,
	    half,
	    r6,
	    r7,
	    w,
	    x,
	    xl,
	    xn,
	    x1,
	    y,
	    z,
	    zz;

	/*******************************************************************/

	elefunt.banner("ttanh");

	ran.ranset(initseed.initseed());

	half = 0.5e0F;
	a = 0.125e0F;
	b = ALOG(3.0e0F) * half;
	c = 1.2435300177159620805e-1F;
	d = ALOG(2.0e0F) + (ait + ONE) * ALOG(beta) * half;
	n = (int)maxtest.maxtest();
	xn = TO_FP_T(n);
	z = ZERO;

	/* random argument accuracy tests */

	for (j = 1; j <= 2; ++j)
	{
	    k1 = 0;
	    k3 = 0;
	    x1 = ZERO;
	    r6 = ZERO;
	    r7 = ZERO;
	    del = (b - a) / xn;
	    xl = a;

	    for (i = 1; i <= n; ++i)
	    {
		x = del * RAN() + xl;
		z = TANH(x);
		y = x - 0.125e0F;
		zz = TANH(y);
		zz = (zz + c) / (ONE + c * zz);
		w = ONE;
		if (z != ZERO)
		    w = (z - zz) / z;
		if (w > ZERO)
		    k1 = k1 + 1;
		if (w < ZERO)
		    k3 = k3 + 1;
		w = ABS(w);
		if (w > r6)
		{
		    r6 = w;
		    x1 = x;
		}
		r7 = r7 + w * w;
		xl = xl + del;
	    }

	    k2 = n - k3 - k1;
	    r7 = SQRT(r7 / xn);
	    System.out.print("1TEST OF TANH(X) VS (TANH(X-1/8)+TANH(1/8))/(1+TANH(X-1/8)TANH(1/8))\n\n");
	    System.out.print(fmt.I(n,7) + " RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL\n");
	    System.out.print("      (" + fmt.E(a,15,4) + "," + fmt.E(b,15,4) + ")\n\n\n");
	    System.out.print(" TANH(X) WAS LARGER" + fmt.I(k1,6) + " TIMES,\n");
	    System.out.print("             AGREED" + fmt.I(k2,6) + " TIMES, AND\n");
	    System.out.print("        WAS SMALLER" + fmt.I(k3,6) + " TIMES.\n\n");
	    System.out.print(" THERE ARE" + fmt.I(machar.it,4) + " BASE" + fmt.I(machar.ibeta,4) +
			     " SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER\n\n");
	    w = -999.0e0F;
	    if (r6 != ZERO)
		w = ALOG(ABS(r6)) / albeta;
	    System.out.print(" THE MAXIMUM RELATIVE ERROR OF" + fmt.E(r6,15,4) +
			     " = " + fmt.I(machar.ibeta,4) + " **" + fmt.F(w,7,2) + "\n");
	    System.out.print("    OCCURRED FOR X =" + fmt.E(x1,17,6) + "\n");
	    w = AMAX1(ait + w, ZERO);
	    System.out.print(" THE ESTIMATED LOSS OF BASE" + fmt.I(machar.ibeta,4) +
			     " SIGNIFICANT DIGITS IS" + fmt.F(w,7,2) + "\n\n\n");
	    w = -999.0e0F;
	    if (r7 != ZERO)
		w = ALOG(ABS(r7)) / albeta;
	    System.out.print(" THE ROOT MEAN SQUARE RELATIVE ERROR WAS" + fmt.E(r7,15,4) +
			     " = " + fmt.I(machar.ibeta,4) + " **" + fmt.F(w,7,2) + "\n");
	    w = AMAX1(ait + w, ZERO);
	    System.out.print(" THE ESTIMATED LOSS OF BASE" + fmt.I(machar.ibeta,4) +
			     " SIGNIFICANT DIGITS IS" + fmt.F(w,7,2) + "\n\n\n");
	    a = b + a;
	    b = d;
	}

	/* special tests */

	System.out.print("1SPECIAL TESTS\n\n");
	System.out.print(" THE IDENTITY   TANH(-X) = -TANH(X)   WILL BE TESTED.\n\n\n");
	System.out.print("        X         F(X) + F(-X)\n\n");

	for (i = 1; i <= 5; ++i)
	{
	    x = RAN();
	    z = TANH(x) + TANH(-x);
	    System.out.print(fmt.E(x,15,7) + fmt.E(z,15,7) + "\n\n");
	}

	System.out.print(" THE IDENTITY TANH(X) = X , X SMALL, WILL BE TESTED.\n\n\n");
	System.out.print("        X         X - F(X)\n\n");
	betap = IPOW(beta, machar.it);
	x = RAN() / betap;

	for (i = 1; i <= 5; ++i)
	{
	    z = x - TANH(x);
	    System.out.print(fmt.E(x,15,7) + fmt.E(z,15,7) + "\n\n");
	    x = x / beta;
	}

	System.out.print(" THE IDENTITY TANH(X) = 1 , X LARGE, WILL BE TESTED.\n\n\n");
	System.out.print("        X         1 - F(X)\n\n");
	x = d;
	b = 4.0e0F;

	for (i = 1; i <= 5; ++i)
	{
	    z = (TANH(x) - half) - half;
	    System.out.print(fmt.E(x,15,7) + fmt.E(z,15,7) + "\n\n");
	    x = x + b;
	}

	System.out.print(" TEST OF UNDERFLOW FOR VERY SMALL ARGUMENT.\n\n");
	expon = TO_FP_T(machar.minexp) *0.75e0F;
	x = POW(beta, expon);
	z = TANH(x);
	System.out.print("       TANH(" + fmt.E(x,13,6) + ") =" + fmt.E(z,13,6) + "\n");
	System.out.print(" THE FUNCTION TANH WILL BE CALLED WITH THE ARGUMENT" +
			 fmt.E(machar.xmax,15,7) + "\n");
	z = TANH(machar.xmax);
	System.out.print("       TANH(" + fmt.E(machar.xmax,13,6) + ") =" +
			 fmt.E(z,13,6) + "\n");
	System.out.print(" THE FUNCTION TANH WILL BE CALLED WITH THE ARGUMENT" +
			 fmt.E(machar.xmin,15,7) + "\n");
	z = TANH(machar.xmin);
	System.out.print("       TANH(" + fmt.E(machar.xmin,13,6) + ") =" +
			 fmt.E(z,13,6) + "\n");
	x = ZERO;
	System.out.print(" THE FUNCTION TANH WILL BE CALLED WITH THE ARGUMENT" +
			 fmt.E(x,15,7) + "\n");
	z = TANH(x);
	System.out.print("       TANH(" + fmt.E(x,13,6) + ") =" +
			 fmt.E(z,13,6) + "\n");
	System.out.print(" THIS CONCLUDES THE TESTS\n");
    }

    public static void main(String[] args)
    {
	ttanh();
    }
}
